import {
	btn,
	Component,
	containerfield,
	displayfield,
	durationfield,
	mapfield,
	MapField,
	numberfield,
	t
} from "@intermesh/goui";
import {jmapds, principalcombo} from "@intermesh/groupoffice-core";

export class ProjectResources extends Component {
	private field: MapField;

	constructor() {
		super();
		this.items.add(

			this.field = mapfield({
				keyFieldName: "employeeId",
				cls: "goui-pit",
				name: "resources",
				buildField: (value) => {
					return containerfield({cls: "hbox gap", style: {padding: ".8rem"}},
						displayfield({
							flex: 1,
							// label: t("User"),
							name: "employeeId",
							renderer: (v, field) => {

								if(!v) {
									return "-";
								}
								return jmapds("Principal").single(v).then(user => user ? user.name : "-")
							}
						}),

						numberfield({
							label: t("Fee"),
							placeholder: t("Use default"),
							name: "fee",
							width: 140,
							decimals: 2
						}),

						durationfield({
							label: t("Budget"),
							name: "budgetMinutes",
							outputFormat: "j",
							width: 140
						}),

						btn({
							icon: "delete",
							handler: button => {
								button.parent!.remove();
							}
						})
					)
				}
			}),

			principalcombo({
				entity: "User",
				label: undefined,
				placeholder: t("Add employee"),
				name: undefined,
				filter: {
					isEmployee: true
				},
				listeners: {
					select: (field, record) => {
						this.field.add({employeeId: field.value}, field.value as string);
						setTimeout(() =>{
							field.reset();
						})
					}
				}
			})
		)

	}
}